"""
##################################################################################
#
# Bänger by Marcin Orlowski
# Because your `banner` deserves to be a `bänger`!
#
# @author    Marcin Orlowski <mail@marcinOrlowski.com>
# Copyright  ©2025 Marcin Orlowski <MarcinOrlowski.com>
# @link      https://github.com/MarcinOrlowski/banger
#
##################################################################################
"""

from .core import BaseFont

"""Matrix built-in font."""


class MatrixFont(BaseFont):
    """A simple 5x3 matrix font.

    Simple 5x3 matrix font with dot-matrix printer style
    """

    _FONT_DATA = {
        "name": "matrix",
        "height": 5,
        "description": "Simple 5x3 matrix font with dot-matrix printer style",
        "bottom_padding": 1,
        "supports_lowercase": False,
        "characters": {
            "default": {"lines": ["", "###", "# #", "###", ""]},
            " ": {"lines": ["  ", "  ", "  ", "  ", "  "], "trim": False},
            "#": {"lines": [" # ", "###", " # ", "###", " # "]},
            "$": {"lines": [" # ", "# #", "###", " # ", "###"]},
            "(": {"lines": ["  #", " # ", "#  ", " # ", "  #"]},
            ")": {"lines": ["#  ", " # ", "  #", " # ", "#  "]},
            "*": {"lines": [" # ", "# #", "###", "# #", " # "]},
            "+": {"lines": ["   ", " # ", "###", " # ", "   "]},
            "/": {"lines": ["  #", " # ", " # ", "#  ", "#  "]},
            ":": {"lines": ["   ", " # ", "   ", " # ", "   "]},
            "[": {"lines": ["## ", "#  ", "#  ", "#  ", "## "]},
            "]": {"lines": [" ##", "  #", "  #", "  #", " ##"]},
            "_": {"lines": ["   ", "   ", "   ", "   ", "###"]},
            "!": {"lines": [" # ", " # ", " # ", "   ", " # "]},
            "-": {"lines": ["   ", "   ", "###", "   ", "   "]},
            ".": {"lines": ["   ", "   ", "   ", "   ", " # "]},
            "0": {"lines": ["###", "# #", "# #", "# #", "###"]},
            "1": {"lines": [" # ", "## ", " # ", " # ", "###"]},
            "2": {"lines": ["###", "  #", "###", "#  ", "###"]},
            "3": {"lines": ["###", "  #", "###", "  #", "###"]},
            "4": {"lines": ["# #", "# #", "###", "  #", "  #"]},
            "5": {"lines": ["###", "#  ", "###", "  #", "###"]},
            "6": {"lines": ["###", "#  ", "###", "# #", "###"]},
            "7": {"lines": ["###", "  #", " # ", "#  ", "#  "]},
            "8": {"lines": ["###", "# #", "###", "# #", "###"]},
            "9": {"lines": ["###", "# #", "###", "  #", "###"]},
            "?": {"lines": ["###", "  #", " # ", "   ", " # "]},
            "A": {"lines": ["###", "# #", "###", "# #", "# #"]},
            "B": {"lines": ["## ", "# #", "## ", "# #", "## "]},
            "C": {"lines": ["###", "#  ", "#  ", "#  ", "###"]},
            "D": {"lines": ["## ", "# #", "# #", "# #", "## "]},
            "E": {"lines": ["###", "#  ", "## ", "#  ", "###"]},
            "F": {"lines": ["###", "#  ", "## ", "#  ", "#  "]},
            "G": {"lines": ["###", "#  ", "# #", "# #", "###"]},
            "H": {"lines": ["# #", "# #", "###", "# #", "# #"]},
            "I": {"lines": ["###", " # ", " # ", " # ", "###"]},
            "J": {"lines": ["  #", "  #", "  #", "# #", "###"]},
            "K": {"lines": ["# #", "## ", "#  ", "## ", "# #"]},
            "L": {"lines": ["#  ", "#  ", "#  ", "#  ", "###"]},
            "M": {"lines": ["# #", "###", "###", "# #", "# #"]},
            "N": {"lines": ["## ", "# #", "# #", "# #", "# #"]},
            "O": {"lines": ["###", "# #", "# #", "# #", "###"]},
            "P": {"lines": ["###", "# #", "###", "#  ", "#  "]},
            "Q": {"lines": ["###", "# #", "# #", "###", "  #"]},
            "R": {"lines": ["###", "# #", "## ", "# #", "# #"]},
            "S": {"lines": ["###", "#  ", "###", "  #", "###"]},
            "T": {"lines": ["###", " # ", " # ", " # ", " # "]},
            "U": {"lines": ["# #", "# #", "# #", "# #", "###"]},
            "V": {"lines": ["# #", "# #", "# #", "# #", " # "]},
            "W": {"lines": ["# #", "# #", "###", "###", "# #"]},
            "X": {"lines": ["# #", " # ", " # ", " # ", "# #"]},
            "Y": {"lines": ["# #", "# #", " # ", " # ", " # "]},
            "Z": {"lines": ["###", "  #", " # ", "#  ", "###"]},
        },
    }
